"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var CodeAction_1 = require("./CodeAction");
/**
 * Represents a code fix action.
 */
var CodeFixAction = /** @class */ (function (_super) {
    tslib_1.__extends(CodeFixAction, _super);
    function CodeFixAction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Short name to identify the fix, for use by telemetry.
     */
    CodeFixAction.prototype.getFixName = function () {
        return this.compilerObject.fixName;
    };
    /**
     * If present, one may call 'getCombinedCodeFix' with this fixId.
     * This may be omitted to indicate that the code fix can't be applied in a group.
     */
    CodeFixAction.prototype.getFixId = function () {
        return this.compilerObject.fixId;
    };
    /**
     * Gets the description of the code fix when fixing everything.
     */
    CodeFixAction.prototype.getFixAllDescription = function () {
        return this.compilerObject.fixAllDescription;
    };
    return CodeFixAction;
}(CodeAction_1.CodeAction));
exports.CodeFixAction = CodeFixAction;
