"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FileTextChanges_1 = require("./FileTextChanges");
/**
 * Represents file changes.
 *
 * Commands are currently not implemented.
 */
var CombinedCodeActions = /** @class */ (function () {
    /** @private */
    function CombinedCodeActions(context, compilerObject) {
        this._context = context;
        this._compilerObject = compilerObject;
    }
    Object.defineProperty(CombinedCodeActions.prototype, "compilerObject", {
        /** Gets the compiler object. */
        get: function () {
            return this._compilerObject;
        },
        enumerable: true,
        configurable: true
    });
    /** Text changes to apply to each file. */
    CombinedCodeActions.prototype.getChanges = function () {
        var _this = this;
        return this.compilerObject.changes.map(function (change) { return new FileTextChanges_1.FileTextChanges(_this._context, change); });
    };
    return CombinedCodeActions;
}());
exports.CombinedCodeActions = CombinedCodeActions;
