"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var typescript_1 = require("../typescript");
var _a = tslib_1.__read(typescript_1.ts.version.split(".").map(function (v) { return parseInt(v, 10); }), 3), tsMajor = _a[0], tsMinor = _a[1], tsPatch = _a[2];
var TypeScriptVersionChecker = /** @class */ (function () {
    function TypeScriptVersionChecker() {
    }
    TypeScriptVersionChecker.isEqual = function (major, minor, patch) {
        return tsMajor === major && tsMinor === minor && tsPatch === patch;
    };
    TypeScriptVersionChecker.isLessThan = function (major, minor, patch) {
        if (tsMajor < major)
            return true;
        if (tsMajor === major && tsMinor < minor)
            return true;
        return tsMajor === major && tsMinor === minor && tsPatch < patch;
    };
    TypeScriptVersionChecker.isLessThanOrEqual = function (major, minor, patch) {
        return TypeScriptVersionChecker.isLessThan(major, minor, patch)
            || TypeScriptVersionChecker.isEqual(major, minor, patch);
    };
    TypeScriptVersionChecker.isGreaterThan = function (major, minor, patch) {
        return !TypeScriptVersionChecker.isLessThanOrEqual(major, minor, patch);
    };
    TypeScriptVersionChecker.isGreaterThanOrEqual = function (major, minor, patch) {
        return !TypeScriptVersionChecker.isLessThan(major, minor, patch);
    };
    return TypeScriptVersionChecker;
}());
exports.TypeScriptVersionChecker = TypeScriptVersionChecker;
